package com.DartChecker;


import android.content.Context;
import android.content.SharedPreferences;
import android.media.AudioAttributes;
import android.media.MediaPlayer;
import android.net.Uri;
import android.os.Build;
import android.os.Handler;
import android.widget.TextView;

import java.io.IOException;
import java.util.ArrayList;

public class dc_modules {

    // get actual size from main score texview (set by autosize), calculate and set size for list entries
    public static void setListSize(TextView mainscore, TextView name, TextView score, TextView checkout) {
        mainscore.measure(0,0);
        int mainScoreSize =  mainscore.getMeasuredHeight();
        double suggsize = mainScoreSize*0.5;
        double namesize = mainScoreSize*0.5;
        double datasize = mainScoreSize*0.66;
        int playerNameHeight = (int) namesize;
        int playerDataHeight = (int) datasize;
        int playerSuggestionHeight = (int) suggsize;
        name.getLayoutParams().height = playerNameHeight;
        score.getLayoutParams().height = playerDataHeight;
        checkout.getLayoutParams().height = playerSuggestionHeight;
    }

    static MediaPlayer mediaplayer = new MediaPlayer() {
    @Override
        public void setOnCompletionListener(OnCompletionListener listener) {
            super.setOnCompletionListener(listener);
            this.release();
        }
    };

    static void playAudio(Context ctx, String TextToPlay) {
        SharedPreferences sp = ctx.getSharedPreferences("Einstellungen",0);
        boolean play=true;
        if (sp.contains("playaudio")) {
            play = sp.getBoolean("playaudio", true);
        }
        if (!play) return;

        int resourceId=0;
        // select soundfile resource
        if (TextToPlay.length() <= 3) { //score is that short only
            resourceId = ctx.getResources().getIdentifier("s" + TextToPlay, "raw", ctx.getPackageName());
        }
        else {
            ArrayList<String> sounds = new ArrayList<>();

            for (int i=1;i<=20;i++) {
                sounds.add("n".concat(Integer.toString(i).concat("closed")));
                sounds.add("n".concat(Integer.toString(i).concat("open")));
            }
            sounds.add("bullopen");
            sounds.add("bullclosed");
            sounds.add("busted");
            sounds.add("madhouse");
            sounds.add("split");
            sounds.add("eliminated");
            sounds.add("closed");
            sounds.add("open");
            sounds.add("matchwinner");
            sounds.add("setwinner");
            sounds.add("winner");
            sounds.add("legwinner");
            sounds.add("requires");
            sounds.add("bull");
            sounds.add("bullseye");
            if (sounds.contains(TextToPlay.toLowerCase()))
                resourceId = ctx.getResources().getIdentifier(TextToPlay.toLowerCase(), "raw", ctx.getPackageName());
        }
        if (resourceId != 0) {
            Uri uri = Uri.parse("android.resource://"+ ctx.getPackageName()+"/"+resourceId);
            new Handler().post(() -> {
                // wait until other sound output has finished
                while (dc_modules.mediaplayer.isPlaying()) {
                }
                mediaplayer.reset();
                if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
                    mediaplayer.setAudioAttributes(
                            new AudioAttributes.Builder()
                                    .setContentType(AudioAttributes.CONTENT_TYPE_MUSIC)
                                    .setUsage(AudioAttributes.USAGE_MEDIA)
                                    .build()
                    );
                }
                try {
                    mediaplayer.setDataSource(ctx, uri);
                    mediaplayer.prepare();
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
                mediaplayer.start();
                });

        }
    }


    // Vorschläge für Checkoutwege berechnen und sortieren
    static ArrayList<String> vorschlaege(int rest, int lieblingsfinish, int DoubleoutOderTripleout) {
        ArrayList<String> ergebnisliste = new ArrayList<>();
        if (rest < 0 || rest > 180) {
            return ergebnisliste;
        }
        // restliche_Punkte = x1*y1 + x2*y2 + x3*y3 = (1.pfeil + 2.pfeil + 3.pfeil)
        // DoubleoutOderTripleout heißt double out = 2 oder master out = 3
        // lieblingsfinish==0 fuer alle varianten
        // rest = x1*y1 + x2*y2 + DoubleoutOderTripleout*y3

        class treffer {
            int rest;
            int x1;
            int y1;
            int x2;
            int y2;
            int x3;
            int y3;
        }

        int x1, x2, y1, y2, y3, z, i2, i;
        treffer[] tl = new treffer[3000];
        treffer[] wanted = new treffer[3000];
        treffer[] unwanted = new treffer[3000];
        boolean zweidartfinishvorhanden, change;
        treffer speicher;
        z = 0;

        // Checkoutmöglichkeiten ermitteln
        for (x1 = 3; x1 >= 0; x1--) {
            for (y1 = 25; y1 >= 1; y1--) {
                if (!(((y1 > 20) && (y1 < 25)) || ((y1 == 25) && (x1 == 3)))) {
                    // 3mal25 gibts nicht und zahlen zw 20 und 25 auch nicht
                    for (x2 = 3; x2 >= 0; x2--) {
                        for (y2 = 25; y2 >= 1; y2--) {
                            if (!(((y2 > 20) && (y2 < 25)) || ((y2 == 25) && (x2 == 3)))) {
                                //3mal25 gibts nicht und....
                                if ((rest - (x1 * y1) - (x2 * y2)) <= 60) {
                                    //doppel checkout theoretisch moeglich?
                                    for (y3 = 25; y3 >= 1; y3--) {
                                        if (!((y3 > 20) && (y3 < 25))) {
                                            // zahlen zw 20 und 25 gibts nicht
                                            int aktuellerRest = (x1 * y1) + (x2 * y2) + (DoubleoutOderTripleout * y3);
                                            if (((rest == aktuellerRest) && (y3 != 0))) {
                                                z++;
                                                // treffer in array speichern
                                                tl[z] = new treffer();
                                                tl[z].rest = aktuellerRest;
                                                if (x1 * y1 <= 20) {
                                                    tl[z].x1 = 1;
                                                    tl[z].y1 = x1 * y1;
                                                } else {
                                                    tl[z].x1 = x1;
                                                    tl[z].y1 = y1;
                                                }
                                                if ((x2 * y2) <= 20) {
                                                    tl[z].x2 = 1;
                                                    tl[z].y2 = x2 * y2;
                                                } else {
                                                    tl[z].x2 = x2;
                                                    tl[z].y2 = y2;
                                                }
                                                tl[z].x3 = DoubleoutOderTripleout;
                                                tl[z].y3 = y3;
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }

        // äquivalente lösungen löschen:
        // array: doppel treffer loeschen, wenn
        //                                 blosse vertauschung der ersten beiden pfeile
        //                                 blosse vertauschung der letzten beiden pfeile
        //                                 1. oder 2. pfeil==0 und der punktepfeil gleich dem anderen bei 0    )
        //
        // DoubleoutOderTripleout = 2 oder 3
        // (rest:= x1*y1 + x2*y2 + DoubleoutOderTripleout*y3 = (1.pfeil + 2.pfeil + 3.pfeil) )

        for (i = 1; i <= z; i++) {
            if (tl[i].rest != 0) { // rest=0 sind gelöschte Treffer
                for (i2 = i + 1; i2 <= z; i2++) {
                    if (tl[i2].rest != 0) { // rest=0 sind gelöschte Treffer
                        if ((tl[i].x1 == tl[i2].x2) && (tl[i].y1 == tl[i2].y2) && (tl[i].x2 == tl[i2].x1) && (tl[i].y2 == tl[i2].y1))
                            tl[i2].rest = 0;
                        if ((tl[i].x1 == 0) && (tl[i].x2 == tl[i2].x2) && (tl[i].y2 == tl[i2].y2))
                            tl[i2].rest = 0;
                        if ((tl[i].x2 == 0) && (tl[i].x1 == tl[i2].x1) && (tl[i].y1 == tl[i2].y1))
                            tl[i2].rest = 0;
                        // wenn 2 Pfeile reichen, überprüfen ob sich nur die Reihenfolge der letzten beiden Darts unterscheidet
                        if ((tl[i].x1 == 0) && (tl[i].x2 == tl[i2].x3) && (tl[i].y2 == tl[i2].y3))
                            tl[i2].rest = 0;
                        if ((tl[i].x2 == 0) && (tl[i].x1 == tl[i2].x3) && (tl[i].y1 == tl[i2].y3))
                            tl[i2].rest = 0;
                        if (((tl[i].x1 == 0) && (tl[i2].x2 == 0)) && ((tl[i].x2 == tl[i2].x1) && (tl[i].y2 == tl[i2].y1)))
                            tl[i2].rest = 0;
                        if (((tl[i].x2 == 0) && (tl[i2].x1 == 0)) && ((tl[i].x1 == tl[i2].x2) && (tl[i].y1 == tl[i2].y2)))
                            tl[i2].rest = 0;
                        // loeschen, wenn 1. und 2. pfeil=0 und gleiches doppel
                        if ((tl[i].y3 == tl[i2].y3) && (tl[i].x1 == 0) && (tl[i2].x1 == 0) && (tl[i].x2 == 0) && (tl[i2].x2 == 0))
                            tl[i2].rest = 0;
                        // löschen, wenn alle pfeile identisch sind
                        if ((tl[i].x1 == tl[i2].x1) && (tl[i].y1 == tl[i2].y1) && (tl[i].x2 == tl[i2].x2) && (tl[i].y2 == tl[i2].y2))
                            tl[i2].rest = 0;
                    }
                }
            }
        }

        // ergebnisse dursuchen nach zweidartfinish
        zweidartfinishvorhanden = false;
        for (i = 1; i <= z; i++) {
            if ((tl[i].x1 == 0) || (tl[i].x2 == 0) || (tl[i].y1 == 0) || (tl[i].y2 == 0)) {
                zweidartfinishvorhanden = true;
                break;
            }
        }

        // relevante ergebnisse in neues, zu sortierendes array kopieren
        i2 = 0;
        for (i = 1; i <= z; i++) {
            if ((tl[i].rest != 0) && ((tl[i].y3 == lieblingsfinish) || (lieblingsfinish == 0) || (lieblingsfinish != 0 && (tl[i].rest < (lieblingsfinish * DoubleoutOderTripleout))))) {
                if ((!zweidartfinishvorhanden)
                        || (zweidartfinishvorhanden && (lieblingsfinish == 0 && ((tl[i].x1 == 0) || (tl[i].x2 == 0) || (tl[i].y1 == 0) || (tl[i].y2 == 0))))
                        || (lieblingsfinish != 0 && (tl[i].rest >= (lieblingsfinish * DoubleoutOderTripleout)))
                        || (lieblingsfinish != 0 && zweidartfinishvorhanden && ((tl[i].x1 == 0) || (tl[i].x2 == 0) || (tl[i].y1 == 0) || (tl[i].y2 == 0)) && (tl[i].rest < (lieblingsfinish * DoubleoutOderTripleout)))) {
                    i2++;
                    wanted[i2] = tl[i];
                }
            }
        }
        int zsafe = z;
        z = i2;
        // sort wanted list
        change = true;
        while (change) {
            change = false;
            for (i = 1; i <= z - 1; i++) {
                // wenn folgeergebnis mitsingle ist, verschiebe mitsingles nach oben bzw. tausche ergebnisse aus
                if ((wanted[i].x1 != 1) && (wanted[i].x2 != 1)) {
                    if ((wanted[i + 1].x1 == 1) || (wanted[i + 1].x2 == 1)) {
                        change = true;
                        speicher = wanted[i];
                        wanted[i] = wanted[i + 1];
                        wanted[i + 1] = speicher;
                    }
                }
            }
        }

        // 2x nach oben
        change = true;
        while (change) {
            change = false;
            for (i = 1; i <= z - 1; i++) {
                // wenn folgeergebnis mitsingle ist, verschiebe mitsingles nach oben bzw. tausche ergebnisse aus
                if ((wanted[i].x1 == 3) && (wanted[i].x2 == 3)) {
                    if (((wanted[i + 1].x1 == 2) && (wanted[i + 1].x2 == 3))
                            || ((wanted[i + 1].x1 == 3) && (wanted[i + 1].x2 == 2))) {
                        change = true;
                        speicher = wanted[i];
                        wanted[i] = wanted[i + 1];
                        wanted[i + 1] = speicher;
                    }
                }
            }
        }

        // if favorite checkout selected, search and add other checkouts to list
        int uw = 0;
        if (lieblingsfinish != 0) {
            for (i = 1; i <= zsafe; i++) {
                if (tl[i].rest != 0) {
                    if (!zweidartfinishvorhanden || tl[i].x1 == 0 || tl[i].x2 == 0 || tl[i].y1 == 0 || tl[i].y2 == 0) {
                        uw++;
                        unwanted[uw] = tl[i];
                    }
                }
            }
            zsafe = uw;

            // sort unwanted list
            change = true;
            while (change) {
                change = false;
                for (i = 1; i <= zsafe - 1; i++) {
                    // wenn folgeergebnis mitsingle ist, verschiebe mitsingles nach oben bzw. tausche ergebnisse aus
                    if ((unwanted[i].x1 != 1) && (unwanted[i].x2 != 1)) {
                        if ((unwanted[i + 1].x1 == 1) || (unwanted[i + 1].x2 == 1)) {
                            change = true;
                            speicher = unwanted[i];
                            unwanted[i] = unwanted[i + 1];
                            unwanted[i + 1] = speicher;
                        }
                    }
                }
            }

            // 2x nach oben
            change = true;
            while (change) {
                change = false;
                for (i = 1; i <= zsafe - 1; i++) {
                    // wenn folgeergebnis mitsingle ist, verschiebe mitsingles nach oben bzw. tausche ergebnisse aus
                    if ((unwanted[i].x1 == 3) && (unwanted[i].x2 == 3)) {
                        if (((unwanted[i + 1].x1 == 2) && (unwanted[i + 1].x2 == 3))
                                || ((unwanted[i + 1].x1 == 3) && (unwanted[i + 1].x2 == 2))) {
                            change = true;
                            speicher = unwanted[i];
                            unwanted[i] = unwanted[i + 1];
                            unwanted[i + 1] = speicher;
                        }
                    }
                }
            }

        }

        ArrayList<treffer> endergebniss = new ArrayList<>();
        for (i = 1; i <= z; i++) {
            endergebniss.add(wanted[i]);
        }

        // add unwanted list, if lieblingsfinsh is selected
        if (lieblingsfinish != 0) {
            for (i = 1; i <= uw; i++) {
                if (!endergebniss.contains(unwanted[i])) {
                    endergebniss.add(unwanted[i]);
                }
            }
        }

        // ausgabe der gewaehlten restlichen treffer in hübscher Formatierung
        // rest:= x1*y1 + x2*y2 + DoubleoutOderTripleout*y3 = (1.pfeil + 2.pfeil + 3.pfeil)
        String dt, str;
        dt = "";
        if (DoubleoutOderTripleout == 2) dt = "D";
        if (DoubleoutOderTripleout == 3) dt = "T";
        i2 = 0;

        ergebnisliste.add("...");
        for (treffer ergebnis : endergebniss) {
            i2++;
            str = "";
            if ((ergebnis.x1 * ergebnis.y1) > 0)
                switch (ergebnis.x1) {
                    case 1:
                        str = str + ergebnis.y1;
                        break;
                    case 2:
                        str = str + "D" + ergebnis.y1;
                        break;
                    case 3:
                        str = str + "T" + ergebnis.y1;
                        break;
                }
            if ((ergebnis.x2 * ergebnis.y2) > 0)
                switch (ergebnis.x2) {
                    case 1:
                        str = str + " " + ergebnis.y2;
                        break;
                    case 2:
                        str = str + " " + "D" + ergebnis.y2;
                        break;
                    case 3:
                        str = str + " " + "T" + ergebnis.y2;
                        break;
                }
            if (str.equals(""))
                str = dt + ergebnis.y3;
            else str = str + " " + dt + ergebnis.y3;

            ergebnisliste.add(str);
        }

        if (rest == 2) {
            ergebnisliste.remove(ergebnisliste.remove(ergebnisliste.size() - 1));
            ergebnisliste.add("MaDhOuSe");
        }
        return ergebnisliste;
    }
}